# Better Font Awesome #

The better Font Awesome plugin for WordPress.

__WordPress Plugin Page:__ [http://wordpress.org/plugins/better-font-awesome/](http://wordpress.org/plugins/better-font-awesome/)  
__Contributors:__ [Mickey Kay](http://profiles.wordpress.org/mcguive7/), [MIGHTYminnow](http://profiles.wordpress.org/mightyminnow/)  
__License:__ [GPL-2.0+](http://www.gnu.org/licenses/gpl-2.0.html)  

## Introduction ##
Better Font Awesome allows you to automatically integrate the latest available version of [Font Awesome](http://fontawesome.io/) into your WordPress project, along with accompanying CSS, shortcode, and TinyMCE icon shortcode generator. Furthermore, it generates all the data you need to create new functionality of your own.

## Screenshots ##
![The Better Font Awesome settings page](https://raw.githubusercontent.com/MickeyKay/better-font-awesome/master/assets/screenshot-1.gif?raw=true)  
_The icon shortcode dropdown selector_

---

![The icon shortcode dropdown selector](https://raw.githubusercontent.com/MickeyKay/better-font-awesome/master/assets/screenshot-2.png?raw=true)  
_The Better Font Awesome settings page_

## Installation ##
The Better Font Awesome plugin contains some [Git submodules](http://git-scm.com/book/en/Git-Tools-Submodules) that will require you to recursively clone this repo:
```
git clone --recursive https://github.com/MickeyKay/better-font-awesome.git
```

Alternately, if you've already cloned the repo and need to add the submodules, you can run the following command:
```
// Initialize all submodules.
git submodule update --init --recursive
```

## The Better Font Awesome Library ##
Better Font Awesome is built around the Better Font Awesome Library, which is available for standalone use in plugins and themes: [https://github.com/MickeyKay/better-font-awesome-library](https://github.com/MickeyKay/better-font-awesome-library)

## Updates ##

This plugin supports the [GitHub Updater](https://github.com/afragen/github-updater) plugin, so if you install that, this plugin becomes automatically updateable direct from GitHub.

## Credits ##
Special thanks to the following folks and their plugins for inspiration and support:
* [Font Awesome Icons](http://wordpress.org/plugins/font-awesome/ "Font Awesome Icons") by [Rachel Baker](http://rachelbaker.me/ "Rachel Baker")
* [Font Awesome More Icons](https://wordpress.org/plugins/font-awesome-more-icons/ "Font Awesome More Icons") by [Web Guys](http://webguysaz.com/ "Web Guys")
* [Font Awesome Shortcodes](https://wordpress.org/plugins/font-awesome-shortcodes/) by [FoolsRun](https://profiles.wordpress.org/foolsrun/ "FoolsRun")
* Dmitriy Akulov and the awesome folks at [jsDelivr](http://www.jsdelivr.com/)

And many thanks to the following folks who helped with testing and QA:
* [Jeffrey Dubinksy](http://vanishingforests.org/)
* [Neil Gee](https://twitter.com/_neilgee)
* [Michael Beil](https://twitter.com/MichaelBeil)
* [Rob Neue](https://twitter.com/rob_neu)
* [Gary Jones](https://twitter.com/GaryJ)
* [Jan Hoek](https://twitter.com/JanHoekdotCom)
