<?php
/**
 * @package ascent
 */
?>

<?php // Styling Tip! 

// Want to wrap for example the post content in blog listings with a thin outline in Bootstrap style?
// Just add the class "panel" to the article tag here that starts below. 
// Simply replace post_class() with post_class('panel') and check your site!   
// Remember to do this for all content templates you want to have this, 
// for example content-single.php for the post single view. ?>

<article id="post-<?php the_ID(); ?>" <?php post_class(); ?>>
    
    <div class="row">
		<?php $format = get_post_format($post->ID); ?>
		<?php if (has_post_thumbnail($post->ID)): ?>
		<div class="col-sm-12 col-md-3">
		    <?php 
		    $image_id = get_post_thumbnail_id();
		    $full_image_url = wp_get_attachment_url($image_id);
		    ?>
		    <?php if ( '' != get_the_post_thumbnail() ): ?>
			<figure>
			    <a class="swipebox" href="<?php echo $full_image_url; ?>" title="<?php the_title(); ?>">
				<?php the_post_thumbnail('blog-page'); ?>
			    </a>
			</figure>
		    <?php endif; ?>
		</div>
		<div class="col-sm-12 col-md-9">
		<?php else: ?>
		<div class="post-content-wrap col-sm-12 col-md-12">
		<?php endif; ?>
		    <header class="page-header">
			<h1 class="entry-title"><a href="<?php the_permalink(); ?>" rel="bookmark"><?php the_title(); ?></a></h1>
			<span class="entry-author">
			    <?php _e('By', 'ascent') ?>
			    <span class="author vcard entry-author-link">
				<?php the_author_posts_link(); ?>
			    </span>
			</span>
		    </header><!-- .entry-header -->
	    
		<?php if ( is_search() || is_archive() ) : // Only display Excerpts for Search and Archive Pages ?>
		    <div class="entry-summary">
			<?php the_excerpt(); ?>
			<a class="read-more" href="<?php the_permalink(); ?>"><?php _e('Read More', 'ascent'); ?></a>
		    </div><!-- .entry-summary -->
		    
		<?php else : ?>
		    
		    <div class="entry-content">			
			
			<?php the_excerpt(); ?>	
			<?php
			    wp_link_pages( array(
				'before' => '<div class="page-links">' . __( 'Pages:', 'ascent' ),
				'after'  => '</div>',
			    ) );
			?>
			<a class="read-more" href="<?php the_permalink(); ?>"><?php _e('Read More', 'ascent'); ?></a>
			
		    </div><!-- .entry-content -->
		<?php endif; ?>
	    
		    <footer class="footer-meta clearfix">
				<?php echo do_shortcode( '[ess_post]' ); ?>	
		    	
		    	<span class="comments_count clearfix entry-comments-link"><?php comments_popup_link(__('0', 'ascent'), __('1', 'ascent'), __('%', 'ascent')); ?></span>

		    </footer><!-- .entry-meta -->			
		</div><!--.post-content-wrap-->
	
    </div><!--.row-->
</article><!-- #post-## -->